/*
    HD44780U and matrix keyboart functions
    Copyright (C) 2009 Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 2 as published by the Free Software Foundation.

*/

#include "config.h"

#define PIN_HD_E 0x01
#define PIN_HD_RS 0x01
#define PIN_HD_RW 0x01
#define PIN_HD_D4 0x01
#define PIN_HD_D5 0x01
#define PIN_HD_D6 0x01
#define PIN_HD_D7 0x01
#define PIN_HD_BUSY PIN_HD_D7

#define PIN_KEYB_A0 0x01
#define PIN_KEYB_A1 0x01
#define PIN_KEYB_A2 0x01

#define LINE_1 0
#define LINE_2 0x40

struct hd{
    struct ftdi_context *ftdi;
    unsigned char wr, rd;
    unsigned char bitmask;
};

struct hd *hd_init(int vid, int pid);
int hd_reset(struct hd *hd);
int hd_setdir(struct hd *hd);
int hd_cmd_nowait(struct hd *hd, char c);
int hd_cmd(struct hd *hd, char c);
int hd_data(struct hd *hd, char c);
int hd_wait(struct hd *hd);
int hd_cmd(struct hd *hd, char c);
#define hd_cursor(hd, c) hd_cmd(hd, 0x80|(c))
int hd_data(struct hd *hd, char c);
void hd_cgram(struct hd *hd, char pos) ;
void hd_print(struct hd *hd, char *str);
void hd_print2(struct hd *hd, char pos, char *str);
int hd_keyb(struct hd *hd);
    
