/*
    misc utils
    Copyright (C) 2007-2009 Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 2 as published by the Free Software Foundation.

*/

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>

#include "misc.h"

int zrandom(void){
    FILE *f;
    int r;

    f=fopen("/dev/urandom", "rb");
    if (f){
        if (fread(&r, 1, sizeof(int), f)!=sizeof(int)){
            r=rand();
        }else{
            r^=rand();
        }
        fclose(f);
    }
    return r;
}


void normtimeval(struct timeval *tv){
    while (tv->tv_usec >= 1000000){
        tv->tv_usec -= 1000000;
        tv->tv_sec ++;
    }
    while (tv->tv_usec < 0){
        tv->tv_usec += 1000000;
        tv->tv_sec --;
    }
}

long int difftimeval_ms(struct timeval *stop, struct timeval *start){
    int sec, usec; 

    usec = stop->tv_usec - start->tv_usec;
    sec = stop->tv_sec - start->tv_sec;
    if (usec < 0){
        usec += 1000000;
        sec --;
    }
    if (sizeof(long) == 4){
        if (sec > 2000000) sec = 2000000;
    }
    if (sizeof(long) == 2){
        if (sec > 63) sec = 63;
    }
    return (long)sec * 1000L + (long)usec / 1000L;
}

long int difftimeval_us(struct timeval *stop, struct timeval *start){
    int sec, usec; 

    usec = stop->tv_usec - start->tv_usec;
    sec = stop->tv_sec - start->tv_sec;
    if (usec < 0){
        usec += 1000000;
        sec --;
    }
    if (sizeof(long) == 4){
        if (sec > 2000) sec = 2000;
    }
    if (sizeof(long) == 2){
        if (sec > 63) sec = 63;
    }
    return (long)sec * 1000000L + (long)usec;
}
