/*
    serial - serial line functions
    Copyright (C) 2009 Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 2 as published by the Free Software Foundation.

*/


#ifndef __SERIAL_H
#define __SERIAL_H

#include "config.h"

#ifdef HAVE_LIBFTDI
#ifdef HAVE_LIBFTDI_STATIC
#include "../libftdi/ftdi.h"
#else
#include <ftdi.h>
#endif
#endif

int serial_parse_string(char *str, int *baudrate, int *bits, char *parity, int *stopbits);

#ifdef HAVE_LIBFTDI
int serial_ftdi_set_line(struct ftdi_context *ftdi, char *str);
#endif

int serial_set_line(int fd, char *str);

#ifdef _WIN32
int serial_win32_line(HANDLE handle, char *str);
#endif

#endif
