#include <inttypes.h>
#include <stdio.h>

#define WAV_RIFF 0x52494646
#define WAV_WAVE 0x57415645
#define WAV_FMT  0x666d7420
#define WAV_DATA 0x64617461

struct dwav_riff{
    uint32_t chunk_id;
    uint32_t chunk_size;
    uint32_t chunk_format;
}__attribute__((__packed__));


struct dwav_subchunk{
    uint32_t subchunk_id;
    uint32_t subchunk_size;
}__attribute__((__packed__));


struct dwav_fmt{
    uint16_t audio_format;
    uint16_t num_channels;
    uint32_t sample_rate;
    uint32_t byte_rate;
    uint16_t bits_per_sample;
}__attribute__((__packed__));



struct wav{
    int bits_per_sample;
    int channels;
    int rate;

    // common
    FILE *f;
    int bpf;    // bytes per frame
    int len_f;
    int len_b;
    int for_write;
    int fmt_len_b;
};

struct wav *wav_open(const char *filename);
int wav_read(struct wav *wav, void *data, int len_f);

struct wav *wav_create(const char *filename);
int wav_write(struct wav *wav, void *data, int len_f);

int wav_close(struct wav *wav);

