/*
    zstring - string functions
    Copyright (C) 2007-2009 Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    version 2 as published by the Free Software Foundation.

*/

#ifndef __ZSTRING_H
#define __ZSTRING_H

#include <stdarg.h>

struct zstring {
    int tokenpos;
    int size;
    char *str;
};

struct zstring *zs_concatesc(char *fmt, ...);
struct zstring *zs_vconcatesc(char *fmt, va_list l);
int zs_writeconcatesc(int fd, char *fmt, ...);

struct zstring *zs_printfesc(char *fmt, ...);
struct zstring *zs_vprintfesc(char *fmt, va_list l);
int zs_writeprintfesc(int fd, char *fmt, ...);

struct zstring *zs_strdup(const char *str);
char *zs_tokenize(struct zstring *zstr, int first);
void zs_free(struct zstring *zstr);
int zs_tokens(struct zstring *zstr);

struct zstring *zs_import_bin(const char *bin, int len);
struct zstring *zs_import_hex(const char *str); // binary data is in zs->str and zs->size

#endif
